There are several events which are raised at different points in the lifecycle of a chart.
ChartCreated Copy Link
The ChartCreated event is raised whenever a chart is first created.
Properties available on the ChartCreatedEvent<TData = any, TContext = any> interface.
Id of the created chart. This can later be used to reference the chart via api methods. |
The grid api. |
Application context as set on gridOptions.context. |
Event identifier |
ChartRangeSelectionChanged Copy Link
This is raised any time that the data range used to render the chart from is changed, e.g. by using the range selection handle or by making changes in the Data tab of the configuration sidebar. This event contains a cellRange object that gives you information about the range, allowing you to recreate the chart.
Properties available on the ChartRangeSelectionChangedEvent<TData = any, TContext = any> interface.
Id of the effected chart. |
Same as chartId. |
New cellRange selected. |
The grid api. |
Application context as set on gridOptions.context. |
Event identifier |
ChartOptionsChanged Copy Link
Any changes made in the panels will raise the ChartOptionsChanged event:
Properties available on the ChartOptionsChangedEvent<TData = any, TContext = any> interface.
Id of the effected chart. |
ChartType |
Chart theme name of currently selected theme. |
Chart options. |
The grid api. |
Application context as set on gridOptions.context. |
Event identifier |
Here the chartThemeName will be set to the name of the currently selected theme, which will be either one of the Provided Themes or a Custom Theme if used.
ChartDestroyed Copy Link
This is raised when a chart is destroyed.
Properties available on the ChartDestroyed<TData = any, TContext = any> interface.
Id of the effected chart. |
The grid api. |
Application context as set on gridOptions.context. |
Event identifier |
Example: Chart Events Copy Link
The following example demonstrates when the described events occur by writing to the console whenever they are triggered. Try the following:
Create a chart from selection, for example, select a few cells in the "Month" and "Sunshine" columns and right-click to "Chart Range" as a "Line" chart. Notice that a "Created chart with ID id-xxxxxxxxxxxxx" message has been logged to the console.
Shrink or expand the selection by a few cells to see the "Changed range selection of chart with ID id-xxxxxxxxxxxx" logged.
Click the Chart Tool Panels Button inside the chart dialog to show chart settings and switch to a column chart. Notice that a "Changed options of chart with ID id-xxxxxxxxxxxxx" message has been logged to the console.
Close the chart dialog to see the "Destroyed chart with ID id-xxxxxxxxxxx" message logged.
import { AgChartsEnterpriseModule } from "ag-charts-enterprise";
import {
ChartCreatedEvent,
ChartDestroyedEvent,
ChartOptionsChangedEvent,
ChartRangeSelectionChangedEvent,
ClientSideRowModelModule,
GridApi,
GridOptions,
ModuleRegistry,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
IntegratedChartsModule,
RowGroupingModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
IntegratedChartsModule.with(AgChartsEnterpriseModule),
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
]);
let gridApi: GridApi;
const gridOptions: GridOptions = {
columnDefs: [
{ field: "Month", width: 150, chartDataType: "category" },
{ field: "Sunshine (hours)", chartDataType: "series" },
{ field: "Rainfall (mm)", chartDataType: "series" },
],
defaultColDef: {
flex: 1,
},
cellSelection: true,
popupParent: document.body,
enableCharts: true,
onChartCreated: onChartCreated,
onChartRangeSelectionChanged: onChartRangeSelectionChanged,
onChartOptionsChanged: onChartOptionsChanged,
onChartDestroyed: onChartDestroyed,
};
function onChartCreated(event: ChartCreatedEvent) {
console.log("Created chart with ID " + event.chartId, event);
}
function onChartRangeSelectionChanged(event: ChartRangeSelectionChangedEvent) {
console.log(
"Changed range selection of chart with ID " + event.chartId,
event,
);
}
function onChartOptionsChanged(event: ChartOptionsChangedEvent) {
console.log("Changed options of chart with ID " + event.chartId, event);
}
function onChartDestroyed(event: ChartDestroyedEvent) {
console.log("Destroyed chart with ID " + event.chartId, event);
}
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/weather-se-england.json")
.then((response) => response.json())
.then(function (data) {
gridApi!.setGridOption("rowData", data);
});
<div id="myGrid" style="height: 100%"></div>
Event Driven Chart Updates Copy Link
The following example updates the chart when ChartRangeSelectionChanged events are raised. Note that charts can be updated using the following Grid API method:
Used to programmatically update a chart. |
Try changing the chart cell range in the grid and notice the subtitle is updated with chart range info.
import { AgChartsEnterpriseModule } from "ag-charts-enterprise";
import {
ChartCreatedEvent,
ChartOptionsChangedEvent,
ChartRangeSelectionChangedEvent,
ClientSideRowModelModule,
CreateRangeChartParams,
FirstDataRenderedEvent,
GridApi,
GridOptions,
ModuleRegistry,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
IntegratedChartsModule,
RowGroupingModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
IntegratedChartsModule.with(AgChartsEnterpriseModule),
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
]);
let gridApi: GridApi;
const gridOptions: GridOptions = {
columnDefs: [
{ field: "Month", width: 150, chartDataType: "category" },
{ field: "Sunshine (hours)", chartDataType: "series" },
{ field: "Rainfall (mm)", chartDataType: "series" },
],
defaultColDef: { flex: 1 },
cellSelection: true,
popupParent: document.body,
enableCharts: true,
chartThemeOverrides: {
common: {
title: { enabled: true, text: "Monthly Weather" },
subtitle: { enabled: true },
legend: { enabled: true },
},
},
onFirstDataRendered: onFirstDataRendered,
onChartCreated: onChartCreated,
onChartRangeSelectionChanged: onChartRangeSelectionChanged,
onChartOptionsChanged: onChartOptionsChanged,
};
function onFirstDataRendered(params: FirstDataRenderedEvent) {
const createRangeChartParams: CreateRangeChartParams = {
cellRange: {
rowStartIndex: 0,
rowEndIndex: 3,
columns: ["Month", "Sunshine (hours)"],
},
chartType: "stackedColumn",
chartContainer: document.querySelector("#myChart") as any,
};
params.api.createRangeChart(createRangeChartParams);
}
function onChartCreated(event: ChartCreatedEvent) {
console.log("Created chart with ID " + event.chartId);
updateTitle(gridApi!, event.chartId);
}
function onChartRangeSelectionChanged(event: ChartRangeSelectionChangedEvent) {
console.log("Changed range selection of chart with ID " + event.chartId);
updateTitle(gridApi!, event.chartId);
}
function onChartOptionsChanged(event: ChartOptionsChangedEvent) {
console.log("Changed options of chart with ID " + event.chartId);
}
function updateTitle(api: GridApi, chartId: string) {
const cellRange = api.getCellRanges()![1];
if (!cellRange) return;
const columnCount = cellRange.columns.length;
const rowCount =
cellRange.endRow!.rowIndex - cellRange.startRow!.rowIndex + 1;
const subtitle = `Using series data from ${columnCount} column(s) and ${rowCount} row(s)`;
api!.updateChart({
type: "rangeChartUpdate",
chartId: chartId,
chartThemeOverrides: {
common: {
subtitle: { text: subtitle },
},
},
});
}
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/weather-se-england.json")
.then((response) => response.json())
.then(function (data) {
gridApi!.setGridOption("rowData", data);
});
.wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
height: 300px;
flex: none;
}
.my-chart {
height: 400px;
flex: none;
}
<div class="wrapper">
<div id="myGrid" class="my-grid"></div>
<div id="myChart" class="my-chart"></div>
</div>
Standalone Chart Events Copy Link
It is possible to subscribe to the AG Charts Events using the theme based configuration via the chartThemeOverrides grid option:
const gridOptions = {
chartThemeOverrides: {
common: {
legend: {
listeners: {
legendItemClick: (e) => console.log('legendItemClick', e)
}
},
listeners: {
seriesNodeClick: (e) => console.log('seriesNodeClick', e)
}
}
},
// other grid options ...
}Note that the chartThemeOverrides grid option maps to AG Charts Theme Overrides.
The example below demonstrates Standalone Charts Events subscription:
- Click on the bars in the series and observe that the
seriesNodeClicklistener emits a console message. - Click on a legend item and observe that the
legendItemClicklistener emits a console message.
import { AgChartLegendClickEvent, AgNodeClickEvent } from "ag-charts-community";
import { AgChartsEnterpriseModule } from "ag-charts-enterprise";
import {
ClientSideRowModelModule,
FirstDataRenderedEvent,
GridApi,
GridOptions,
ModuleRegistry,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
IntegratedChartsModule,
RowGroupingModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
IntegratedChartsModule.with(AgChartsEnterpriseModule),
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
]);
let gridApi: GridApi;
const gridOptions: GridOptions = {
columnDefs: [
{ field: "Month", chartDataType: "category", width: 150 },
{ field: "Sunshine (hours)", chartDataType: "series" },
{ field: "Rainfall (mm)", chartDataType: "series" },
],
defaultColDef: {
flex: 1,
},
cellSelection: true,
popupParent: document.body,
enableCharts: true,
chartThemeOverrides: {
common: {
legend: {
listeners: {
legendItemClick: (e: AgChartLegendClickEvent) =>
console.log("legendItemClick", e),
},
},
listeners: {
seriesNodeClick: (e: AgNodeClickEvent<any, any>) =>
console.log("seriesNodeClick", e),
},
},
},
onFirstDataRendered: onFirstDataRendered,
};
function onFirstDataRendered(params: FirstDataRenderedEvent) {
params.api.createRangeChart({
chartContainer: document.querySelector("#myChart") as HTMLElement,
cellRange: { columns: ["Month", "Sunshine (hours)", "Rainfall (mm)"] },
chartType: "groupedColumn",
});
}
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/weather-se-england.json")
.then((response) => response.json())
.then(function (data) {
gridApi!.setGridOption("rowData", data);
});
.wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
height: 300px;
flex: none;
}
.my-chart {
height: 400px;
flex: none;
}
<div class="wrapper">
<div id="myGrid" class="my-grid"></div>
<div id="myChart" class="my-chart"></div>
</div>

There are several events which are raised at different points in the lifecycle of a chart.
ChartCreated Copy Link
The ChartCreated event is raised whenever a chart is first created.
Properties available on the ChartCreatedEvent<TData = any, TContext = any> interface.
Id of the created chart. This can later be used to reference the chart via api methods. |
The grid api. |
Application context as set on gridOptions.context. |
Event identifier |
ChartRangeSelectionChanged Copy Link
This is raised any time that the data range used to render the chart from is changed, e.g. by using the range selection handle or by making changes in the Data tab of the configuration sidebar. This event contains a cellRange object that gives you information about the range, allowing you to recreate the chart.
Properties available on the ChartRangeSelectionChangedEvent<TData = any, TContext = any> interface.
Id of the effected chart. |
Same as chartId. |
New cellRange selected. |
The grid api. |
Application context as set on gridOptions.context. |
Event identifier |
ChartOptionsChanged Copy Link
Any changes made in the panels will raise the ChartOptionsChanged event:
Properties available on the ChartOptionsChangedEvent<TData = any, TContext = any> interface.
Id of the effected chart. |
ChartType |
Chart theme name of currently selected theme. |
Chart options. |
The grid api. |
Application context as set on gridOptions.context. |
Event identifier |
Here the chartThemeName will be set to the name of the currently selected theme, which will be either one of the Provided Themes or a Custom Theme if used.
ChartDestroyed Copy Link
This is raised when a chart is destroyed.
Properties available on the ChartDestroyed<TData = any, TContext = any> interface.
Id of the effected chart. |
The grid api. |
Application context as set on gridOptions.context. |
Event identifier |
Example: Chart Events Copy Link
The following example demonstrates when the described events occur by writing to the console whenever they are triggered. Try the following:
Create a chart from selection, for example, select a few cells in the "Month" and "Sunshine" columns and right-click to "Chart Range" as a "Line" chart. Notice that a "Created chart with ID id-xxxxxxxxxxxxx" message has been logged to the console.
Shrink or expand the selection by a few cells to see the "Changed range selection of chart with ID id-xxxxxxxxxxxx" logged.
Click the Chart Tool Panels Button inside the chart dialog to show chart settings and switch to a column chart. Notice that a "Changed options of chart with ID id-xxxxxxxxxxxxx" message has been logged to the console.
Close the chart dialog to see the "Destroyed chart with ID id-xxxxxxxxxxx" message logged.
("use client");
import React, {
useCallback,
useMemo,
useRef,
useState,
useEffect,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import { AgChartsEnterpriseModule } from "ag-charts-enterprise";
import {
CellSelectionOptions,
ChartCreatedEvent,
ChartDestroyedEvent,
ChartOptionsChangedEvent,
ChartRangeSelectionChangedEvent,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
IntegratedChartsModule,
RowGroupingModule,
} from "ag-grid-enterprise";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
ClientSideRowModelModule,
IntegratedChartsModule.with(AgChartsEnterpriseModule),
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
];
const GridExample = () => {
const gridRef = useRef<AgGridReact>(null);
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "Month", width: 150, chartDataType: "category" },
{ field: "Sunshine (hours)", chartDataType: "series" },
{ field: "Rainfall (mm)", chartDataType: "series" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
};
}, []);
const popupParent = useMemo<HTMLElement | null>(() => {
return document.body;
}, []);
const { data, loading } = useFetchJson<any>(
"https://www.ag-grid.com/example-assets/weather-se-england.json",
);
const onChartCreated = useCallback((event: ChartCreatedEvent) => {
console.log("Created chart with ID " + event.chartId, event);
}, []);
const onChartRangeSelectionChanged = useCallback(
(event: ChartRangeSelectionChangedEvent) => {
console.log(
"Changed range selection of chart with ID " + event.chartId,
event,
);
},
[],
);
const onChartOptionsChanged = useCallback(
(event: ChartOptionsChangedEvent) => {
console.log("Changed options of chart with ID " + event.chartId, event);
},
[],
);
const onChartDestroyed = useCallback((event: ChartDestroyedEvent) => {
console.log("Destroyed chart with ID " + event.chartId, event);
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact
ref={gridRef}
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
cellSelection={true}
popupParent={popupParent}
enableCharts={true}
onChartCreated={onChartCreated}
onChartRangeSelectionChanged={onChartRangeSelectionChanged}
onChartOptionsChanged={onChartOptionsChanged}
onChartDestroyed={onChartDestroyed}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
}; Event Driven Chart Updates Copy Link
The following example updates the chart when ChartRangeSelectionChanged events are raised. Note that charts can be updated using the following Grid API method:
Used to programmatically update a chart. |
Try changing the chart cell range in the grid and notice the subtitle is updated with chart range info.
("use client");
import React, {
useCallback,
useMemo,
useRef,
useState,
useEffect,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./style.css";
import { AgChartsEnterpriseModule } from "ag-charts-enterprise";
import {
AgChartThemeOverrides,
CellSelectionOptions,
ChartCreatedEvent,
ChartOptionsChangedEvent,
ChartRangeSelectionChangedEvent,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
CreateRangeChartParams,
FirstDataRenderedEvent,
GridApi,
GridOptions,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
IntegratedChartsModule,
RowGroupingModule,
} from "ag-grid-enterprise";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
ClientSideRowModelModule,
IntegratedChartsModule.with(AgChartsEnterpriseModule),
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
];
function updateTitle(api: GridApi, chartId: string) {
const cellRange = api.getCellRanges()![1];
if (!cellRange) return;
const columnCount = cellRange.columns.length;
const rowCount =
cellRange.endRow!.rowIndex - cellRange.startRow!.rowIndex + 1;
const subtitle = `Using series data from ${columnCount} column(s) and ${rowCount} row(s)`;
api!.updateChart({
type: "rangeChartUpdate",
chartId: chartId,
chartThemeOverrides: {
common: {
subtitle: { text: subtitle },
},
},
});
}
const GridExample = () => {
const gridRef = useRef<AgGridReact>(null);
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "Month", width: 150, chartDataType: "category" },
{ field: "Sunshine (hours)", chartDataType: "series" },
{ field: "Rainfall (mm)", chartDataType: "series" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return { flex: 1 };
}, []);
const popupParent = useMemo<HTMLElement | null>(() => {
return document.body;
}, []);
const chartThemeOverrides = useMemo<AgChartThemeOverrides>(() => {
return {
common: {
title: { enabled: true, text: "Monthly Weather" },
subtitle: { enabled: true },
legend: { enabled: true },
},
};
}, []);
const { data, loading } = useFetchJson<any>(
"https://www.ag-grid.com/example-assets/weather-se-england.json",
);
const onFirstDataRendered = useCallback((params: FirstDataRenderedEvent) => {
const createRangeChartParams: CreateRangeChartParams = {
cellRange: {
rowStartIndex: 0,
rowEndIndex: 3,
columns: ["Month", "Sunshine (hours)"],
},
chartType: "stackedColumn",
chartContainer: document.querySelector("#myChart") as any,
};
params.api.createRangeChart(createRangeChartParams);
}, []);
const onChartCreated = useCallback((event: ChartCreatedEvent) => {
console.log("Created chart with ID " + event.chartId);
updateTitle(gridRef.current!.api!, event.chartId);
}, []);
const onChartRangeSelectionChanged = useCallback(
(event: ChartRangeSelectionChangedEvent) => {
console.log("Changed range selection of chart with ID " + event.chartId);
updateTitle(gridRef.current!.api!, event.chartId);
},
[],
);
const onChartOptionsChanged = useCallback(
(event: ChartOptionsChangedEvent) => {
console.log("Changed options of chart with ID " + event.chartId);
},
[],
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div className="wrapper">
<div style={gridStyle} className="my-grid">
<AgGridReact
ref={gridRef}
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
cellSelection={true}
popupParent={popupParent}
enableCharts={true}
chartThemeOverrides={chartThemeOverrides}
onFirstDataRendered={onFirstDataRendered}
onChartCreated={onChartCreated}
onChartRangeSelectionChanged={onChartRangeSelectionChanged}
onChartOptionsChanged={onChartOptionsChanged}
/>
</div>
<div id="myChart" className="my-chart"></div>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
height: 300px;
flex: none;
}
.my-chart {
height: 400px;
flex: none;
}
import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
}; Standalone Chart Events Copy Link
It is possible to subscribe to the AG Charts Events using the theme based configuration via the chartThemeOverrides grid option:
const chartThemeOverrides = useMemo(() => {
return {
common: {
legend: {
listeners: {
legendItemClick: (e) => console.log('legendItemClick', e)
}
},
listeners: {
seriesNodeClick: (e) => console.log('seriesNodeClick', e)
}
}
};
}, []);
<AgGridReact chartThemeOverrides={chartThemeOverrides} />Note that the chartThemeOverrides grid option maps to AG Charts Theme Overrides.
The example below demonstrates Standalone Charts Events subscription:
- Click on the bars in the series and observe that the
seriesNodeClicklistener emits a console message. - Click on a legend item and observe that the
legendItemClicklistener emits a console message.
("use client");
import React, {
useCallback,
useMemo,
useRef,
useState,
useEffect,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./style.css";
import { AgChartLegendClickEvent, AgNodeClickEvent } from "ag-charts-community";
import { AgChartsEnterpriseModule } from "ag-charts-enterprise";
import {
AgChartThemeOverrides,
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
FirstDataRenderedEvent,
GridApi,
GridOptions,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
IntegratedChartsModule,
RowGroupingModule,
} from "ag-grid-enterprise";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
ClientSideRowModelModule,
IntegratedChartsModule.with(AgChartsEnterpriseModule),
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
];
const GridExample = () => {
const gridRef = useRef<AgGridReact>(null);
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "Month", chartDataType: "category", width: 150 },
{ field: "Sunshine (hours)", chartDataType: "series" },
{ field: "Rainfall (mm)", chartDataType: "series" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
};
}, []);
const popupParent = useMemo<HTMLElement | null>(() => {
return document.body;
}, []);
const chartThemeOverrides = useMemo<AgChartThemeOverrides>(() => {
return {
common: {
legend: {
listeners: {
legendItemClick: (e: AgChartLegendClickEvent) =>
console.log("legendItemClick", e),
},
},
listeners: {
seriesNodeClick: (e: AgNodeClickEvent<any, any>) =>
console.log("seriesNodeClick", e),
},
},
};
}, []);
const { data, loading } = useFetchJson<any>(
"https://www.ag-grid.com/example-assets/weather-se-england.json",
);
const onFirstDataRendered = useCallback((params: FirstDataRenderedEvent) => {
params.api.createRangeChart({
chartContainer: document.querySelector("#myChart") as HTMLElement,
cellRange: { columns: ["Month", "Sunshine (hours)", "Rainfall (mm)"] },
chartType: "groupedColumn",
});
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div className="wrapper">
<div style={gridStyle} className="my-grid">
<AgGridReact
ref={gridRef}
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
cellSelection={true}
popupParent={popupParent}
enableCharts={true}
chartThemeOverrides={chartThemeOverrides}
onFirstDataRendered={onFirstDataRendered}
/>
</div>
<div id="myChart" className="my-chart"></div>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
height: 300px;
flex: none;
}
.my-chart {
height: 400px;
flex: none;
}
import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
};

There are several events which are raised at different points in the lifecycle of a chart.
ChartCreated Copy Link
The ChartCreated event is raised whenever a chart is first created.
Properties available on the ChartCreatedEvent<TData = any, TContext = any> interface.
Id of the created chart. This can later be used to reference the chart via api methods. |
The grid api. |
Application context as set on gridOptions.context. |
Event identifier |
ChartRangeSelectionChanged Copy Link
This is raised any time that the data range used to render the chart from is changed, e.g. by using the range selection handle or by making changes in the Data tab of the configuration sidebar. This event contains a cellRange object that gives you information about the range, allowing you to recreate the chart.
Properties available on the ChartRangeSelectionChangedEvent<TData = any, TContext = any> interface.
Id of the effected chart. |
Same as chartId. |
New cellRange selected. |
The grid api. |
Application context as set on gridOptions.context. |
Event identifier |
ChartOptionsChanged Copy Link
Any changes made in the panels will raise the ChartOptionsChanged event:
Properties available on the ChartOptionsChangedEvent<TData = any, TContext = any> interface.
Id of the effected chart. |
ChartType |
Chart theme name of currently selected theme. |
Chart options. |
The grid api. |
Application context as set on gridOptions.context. |
Event identifier |
Here the chartThemeName will be set to the name of the currently selected theme, which will be either one of the Provided Themes or a Custom Theme if used.
ChartDestroyed Copy Link
This is raised when a chart is destroyed.
Properties available on the ChartDestroyed<TData = any, TContext = any> interface.
Id of the effected chart. |
The grid api. |
Application context as set on gridOptions.context. |
Event identifier |
Example: Chart Events Copy Link
The following example demonstrates when the described events occur by writing to the console whenever they are triggered. Try the following:
Create a chart from selection, for example, select a few cells in the "Month" and "Sunshine" columns and right-click to "Chart Range" as a "Line" chart. Notice that a "Created chart with ID id-xxxxxxxxxxxxx" message has been logged to the console.
Shrink or expand the selection by a few cells to see the "Changed range selection of chart with ID id-xxxxxxxxxxxx" logged.
Click the Chart Tool Panels Button inside the chart dialog to show chart settings and switch to a column chart. Notice that a "Changed options of chart with ID id-xxxxxxxxxxxxx" message has been logged to the console.
Close the chart dialog to see the "Destroyed chart with ID id-xxxxxxxxxxx" message logged.
import { Component, ViewChild } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import { AgChartsEnterpriseModule } from "ag-charts-enterprise";
import {
CellSelectionOptions,
ChartCreatedEvent,
ChartDestroyedEvent,
ChartOptionsChangedEvent,
ChartRangeSelectionChangedEvent,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
IntegratedChartsModule,
RowGroupingModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
IntegratedChartsModule.with(AgChartsEnterpriseModule),
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[cellSelection]="true"
[popupParent]="popupParent"
[enableCharts]="true"
[rowData]="rowData"
(chartCreated)="onChartCreated($event)"
(chartRangeSelectionChanged)="onChartRangeSelectionChanged($event)"
(chartOptionsChanged)="onChartOptionsChanged($event)"
(chartDestroyed)="onChartDestroyed($event)"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "Month", width: 150, chartDataType: "category" },
{ field: "Sunshine (hours)", chartDataType: "series" },
{ field: "Rainfall (mm)", chartDataType: "series" },
];
defaultColDef: ColDef = {
flex: 1,
};
popupParent: HTMLElement | null = document.body;
rowData!: any[];
constructor(private http: HttpClient) {}
onChartCreated(event: ChartCreatedEvent) {
console.log("Created chart with ID " + event.chartId, event);
}
onChartRangeSelectionChanged(event: ChartRangeSelectionChangedEvent) {
console.log(
"Changed range selection of chart with ID " + event.chartId,
event,
);
}
onChartOptionsChanged(event: ChartOptionsChangedEvent) {
console.log("Changed options of chart with ID " + event.chartId, event);
}
onChartDestroyed(event: ChartDestroyedEvent) {
console.log("Destroyed chart with ID " + event.chartId, event);
}
onGridReady(params: GridReadyEvent) {
this.http
.get<
any[]
>("https://www.ag-grid.com/example-assets/weather-se-england.json")
.subscribe((data) => {
this.rowData = data;
});
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
Event Driven Chart Updates Copy Link
The following example updates the chart when ChartRangeSelectionChanged events are raised. Note that charts can be updated using the following Grid API method:
Used to programmatically update a chart. |
Try changing the chart cell range in the grid and notice the subtitle is updated with chart range info.
import { Component, ViewChild } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./style.css";
import { AgChartsEnterpriseModule } from "ag-charts-enterprise";
import {
AgChartThemeOverrides,
CellSelectionOptions,
ChartCreatedEvent,
ChartOptionsChangedEvent,
ChartRangeSelectionChangedEvent,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
CreateRangeChartParams,
FirstDataRenderedEvent,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
IntegratedChartsModule,
RowGroupingModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
IntegratedChartsModule.with(AgChartsEnterpriseModule),
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<div class="wrapper">
<ag-grid-angular
style="width: 100%; height: 100%;"
class="my-grid"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[cellSelection]="true"
[popupParent]="popupParent"
[enableCharts]="true"
[chartThemeOverrides]="chartThemeOverrides"
[rowData]="rowData"
(firstDataRendered)="onFirstDataRendered($event)"
(chartCreated)="onChartCreated($event)"
(chartRangeSelectionChanged)="onChartRangeSelectionChanged($event)"
(chartOptionsChanged)="onChartOptionsChanged($event)"
(gridReady)="onGridReady($event)"
/>
<div id="myChart" class="my-chart"></div>
</div> `,
})
export class AppComponent {
private gridApi!: GridApi;
columnDefs: ColDef[] = [
{ field: "Month", width: 150, chartDataType: "category" },
{ field: "Sunshine (hours)", chartDataType: "series" },
{ field: "Rainfall (mm)", chartDataType: "series" },
];
defaultColDef: ColDef = { flex: 1 };
popupParent: HTMLElement | null = document.body;
chartThemeOverrides: AgChartThemeOverrides = {
common: {
title: { enabled: true, text: "Monthly Weather" },
subtitle: { enabled: true },
legend: { enabled: true },
},
};
rowData!: any[];
constructor(private http: HttpClient) {}
onFirstDataRendered(params: FirstDataRenderedEvent) {
const createRangeChartParams: CreateRangeChartParams = {
cellRange: {
rowStartIndex: 0,
rowEndIndex: 3,
columns: ["Month", "Sunshine (hours)"],
},
chartType: "stackedColumn",
chartContainer: document.querySelector("#myChart") as any,
};
params.api.createRangeChart(createRangeChartParams);
}
onChartCreated(event: ChartCreatedEvent) {
console.log("Created chart with ID " + event.chartId);
updateTitle(this.gridApi, event.chartId);
}
onChartRangeSelectionChanged(event: ChartRangeSelectionChangedEvent) {
console.log("Changed range selection of chart with ID " + event.chartId);
updateTitle(this.gridApi, event.chartId);
}
onChartOptionsChanged(event: ChartOptionsChangedEvent) {
console.log("Changed options of chart with ID " + event.chartId);
}
onGridReady(params: GridReadyEvent) {
this.gridApi = params.api;
this.http
.get<
any[]
>("https://www.ag-grid.com/example-assets/weather-se-england.json")
.subscribe((data) => {
this.rowData = data;
});
}
}
function updateTitle(api: GridApi, chartId: string) {
const cellRange = api.getCellRanges()![1];
if (!cellRange) return;
const columnCount = cellRange.columns.length;
const rowCount =
cellRange.endRow!.rowIndex - cellRange.startRow!.rowIndex + 1;
const subtitle = `Using series data from ${columnCount} column(s) and ${rowCount} row(s)`;
api!.updateChart({
type: "rangeChartUpdate",
chartId: chartId,
chartThemeOverrides: {
common: {
subtitle: { text: subtitle },
},
},
});
}
.wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
height: 300px;
flex: none;
}
.my-chart {
height: 400px;
flex: none;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
Standalone Chart Events Copy Link
It is possible to subscribe to the AG Charts Events using the theme based configuration via the chartThemeOverrides grid option:
<ag-grid-angular
[chartThemeOverrides]="chartThemeOverrides"
/* other grid options ... */ />
this.chartThemeOverrides = {
common: {
legend: {
listeners: {
legendItemClick: (e) => console.log('legendItemClick', e)
}
},
listeners: {
seriesNodeClick: (e) => console.log('seriesNodeClick', e)
}
}
;Note that the chartThemeOverrides grid option maps to AG Charts Theme Overrides.
The example below demonstrates Standalone Charts Events subscription:
- Click on the bars in the series and observe that the
seriesNodeClicklistener emits a console message. - Click on a legend item and observe that the
legendItemClicklistener emits a console message.
import { Component, ViewChild } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./style.css";
import { AgChartLegendClickEvent, AgNodeClickEvent } from "ag-charts-community";
import { AgChartsEnterpriseModule } from "ag-charts-enterprise";
import {
AgChartThemeOverrides,
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
FirstDataRenderedEvent,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
IntegratedChartsModule,
RowGroupingModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
IntegratedChartsModule.with(AgChartsEnterpriseModule),
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<div class="wrapper">
<ag-grid-angular
style="width: 100%; height: 100%;"
class="my-grid"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[cellSelection]="true"
[popupParent]="popupParent"
[enableCharts]="true"
[chartThemeOverrides]="chartThemeOverrides"
[rowData]="rowData"
(firstDataRendered)="onFirstDataRendered($event)"
(gridReady)="onGridReady($event)"
/>
<div id="myChart" class="my-chart"></div>
</div> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "Month", chartDataType: "category", width: 150 },
{ field: "Sunshine (hours)", chartDataType: "series" },
{ field: "Rainfall (mm)", chartDataType: "series" },
];
defaultColDef: ColDef = {
flex: 1,
};
popupParent: HTMLElement | null = document.body;
chartThemeOverrides: AgChartThemeOverrides = {
common: {
legend: {
listeners: {
legendItemClick: (e: AgChartLegendClickEvent) =>
console.log("legendItemClick", e),
},
},
listeners: {
seriesNodeClick: (e: AgNodeClickEvent<any, any>) =>
console.log("seriesNodeClick", e),
},
},
};
rowData!: any[];
constructor(private http: HttpClient) {}
onFirstDataRendered(params: FirstDataRenderedEvent) {
params.api.createRangeChart({
chartContainer: document.querySelector("#myChart") as HTMLElement,
cellRange: { columns: ["Month", "Sunshine (hours)", "Rainfall (mm)"] },
chartType: "groupedColumn",
});
}
onGridReady(params: GridReadyEvent) {
this.http
.get<
any[]
>("https://www.ag-grid.com/example-assets/weather-se-england.json")
.subscribe((data) => {
this.rowData = data;
});
}
}
.wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
height: 300px;
flex: none;
}
.my-chart {
height: 400px;
flex: none;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});

There are several events which are raised at different points in the lifecycle of a chart.
ChartCreated Copy Link
The ChartCreated event is raised whenever a chart is first created.
Properties available on the ChartCreatedEvent<TData = any, TContext = any> interface.
Id of the created chart. This can later be used to reference the chart via api methods. |
The grid api. |
Application context as set on gridOptions.context. |
Event identifier |
ChartRangeSelectionChanged Copy Link
This is raised any time that the data range used to render the chart from is changed, e.g. by using the range selection handle or by making changes in the Data tab of the configuration sidebar. This event contains a cellRange object that gives you information about the range, allowing you to recreate the chart.
Properties available on the ChartRangeSelectionChangedEvent<TData = any, TContext = any> interface.
Id of the effected chart. |
Same as chartId. |
New cellRange selected. |
The grid api. |
Application context as set on gridOptions.context. |
Event identifier |
ChartOptionsChanged Copy Link
Any changes made in the panels will raise the ChartOptionsChanged event:
Properties available on the ChartOptionsChangedEvent<TData = any, TContext = any> interface.
Id of the effected chart. |
ChartType |
Chart theme name of currently selected theme. |
Chart options. |
The grid api. |
Application context as set on gridOptions.context. |
Event identifier |
Here the chartThemeName will be set to the name of the currently selected theme, which will be either one of the Provided Themes or a Custom Theme if used.
ChartDestroyed Copy Link
This is raised when a chart is destroyed.
Properties available on the ChartDestroyed<TData = any, TContext = any> interface.
Id of the effected chart. |
The grid api. |
Application context as set on gridOptions.context. |
Event identifier |
Example: Chart Events Copy Link
The following example demonstrates when the described events occur by writing to the console whenever they are triggered. Try the following:
Create a chart from selection, for example, select a few cells in the "Month" and "Sunshine" columns and right-click to "Chart Range" as a "Line" chart. Notice that a "Created chart with ID id-xxxxxxxxxxxxx" message has been logged to the console.
Shrink or expand the selection by a few cells to see the "Changed range selection of chart with ID id-xxxxxxxxxxxx" logged.
Click the Chart Tool Panels Button inside the chart dialog to show chart settings and switch to a column chart. Notice that a "Changed options of chart with ID id-xxxxxxxxxxxxx" message has been logged to the console.
Close the chart dialog to see the "Destroyed chart with ID id-xxxxxxxxxxx" message logged.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import { AgChartsEnterpriseModule } from "ag-charts-enterprise";
import {
CellSelectionOptions,
ChartCreatedEvent,
ChartDestroyedEvent,
ChartOptionsChangedEvent,
ChartRangeSelectionChangedEvent,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
IntegratedChartsModule,
RowGroupingModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
IntegratedChartsModule.with(AgChartsEnterpriseModule),
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:cellSelection="true"
:popupParent="popupParent"
:enableCharts="true"
:rowData="rowData"
@chart-created="onChartCreated"
@chart-range-selection-changed="onChartRangeSelectionChanged"
@chart-options-changed="onChartOptionsChanged"
@chart-destroyed="onChartDestroyed"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "Month", width: 150, chartDataType: "category" },
{ field: "Sunshine (hours)", chartDataType: "series" },
{ field: "Rainfall (mm)", chartDataType: "series" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
});
const popupParent = ref<HTMLElement | null>(document.body);
const rowData = ref<any[]>(null);
function onChartCreated(event: ChartCreatedEvent) {
console.log("Created chart with ID " + event.chartId, event);
}
function onChartRangeSelectionChanged(
event: ChartRangeSelectionChangedEvent,
) {
console.log(
"Changed range selection of chart with ID " + event.chartId,
event,
);
}
function onChartOptionsChanged(event: ChartOptionsChangedEvent) {
console.log("Changed options of chart with ID " + event.chartId, event);
}
function onChartDestroyed(event: ChartDestroyedEvent) {
console.log("Destroyed chart with ID " + event.chartId, event);
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => {
rowData.value = data;
};
fetch("https://www.ag-grid.com/example-assets/weather-se-england.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
popupParent,
rowData,
onGridReady,
onChartCreated,
onChartRangeSelectionChanged,
onChartOptionsChanged,
onChartDestroyed,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Event Driven Chart Updates Copy Link
The following example updates the chart when ChartRangeSelectionChanged events are raised. Note that charts can be updated using the following Grid API method:
Used to programmatically update a chart. |
Try changing the chart cell range in the grid and notice the subtitle is updated with chart range info.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./style.css";
import { AgChartsEnterpriseModule } from "ag-charts-enterprise";
import {
AgChartThemeOverrides,
CellSelectionOptions,
ChartCreatedEvent,
ChartOptionsChangedEvent,
ChartRangeSelectionChangedEvent,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
CreateRangeChartParams,
FirstDataRenderedEvent,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
IntegratedChartsModule,
RowGroupingModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
IntegratedChartsModule.with(AgChartsEnterpriseModule),
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
]);
function updateTitle(api: GridApi, chartId: string) {
const cellRange = api.getCellRanges()![1];
if (!cellRange) return;
const columnCount = cellRange.columns.length;
const rowCount =
cellRange.endRow!.rowIndex - cellRange.startRow!.rowIndex + 1;
const subtitle = `Using series data from ${columnCount} column(s) and ${rowCount} row(s)`;
api!.updateChart({
type: "rangeChartUpdate",
chartId: chartId,
chartThemeOverrides: {
common: {
subtitle: { text: subtitle },
},
},
});
}
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div class="wrapper">
<ag-grid-vue
style="width: 100%; height: 100%;"
class="my-grid"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:cellSelection="true"
:popupParent="popupParent"
:enableCharts="true"
:chartThemeOverrides="chartThemeOverrides"
:rowData="rowData"
@first-data-rendered="onFirstDataRendered"
@chart-created="onChartCreated"
@chart-range-selection-changed="onChartRangeSelectionChanged"
@chart-options-changed="onChartOptionsChanged"></ag-grid-vue>
<div id="myChart" class="my-chart"></div>
</div>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "Month", width: 150, chartDataType: "category" },
{ field: "Sunshine (hours)", chartDataType: "series" },
{ field: "Rainfall (mm)", chartDataType: "series" },
]);
const defaultColDef = ref<ColDef>({ flex: 1 });
const popupParent = ref<HTMLElement | null>(document.body);
const chartThemeOverrides = ref<AgChartThemeOverrides>({
common: {
title: { enabled: true, text: "Monthly Weather" },
subtitle: { enabled: true },
legend: { enabled: true },
},
});
const rowData = ref<any[]>(null);
function onFirstDataRendered(params: FirstDataRenderedEvent) {
const createRangeChartParams: CreateRangeChartParams = {
cellRange: {
rowStartIndex: 0,
rowEndIndex: 3,
columns: ["Month", "Sunshine (hours)"],
},
chartType: "stackedColumn",
chartContainer: document.querySelector("#myChart") as any,
};
params.api.createRangeChart(createRangeChartParams);
}
function onChartCreated(event: ChartCreatedEvent) {
console.log("Created chart with ID " + event.chartId);
updateTitle(gridApi.value!, event.chartId);
}
function onChartRangeSelectionChanged(
event: ChartRangeSelectionChangedEvent,
) {
console.log("Changed range selection of chart with ID " + event.chartId);
updateTitle(gridApi.value!, event.chartId);
}
function onChartOptionsChanged(event: ChartOptionsChangedEvent) {
console.log("Changed options of chart with ID " + event.chartId);
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => {
rowData.value = data;
};
fetch("https://www.ag-grid.com/example-assets/weather-se-england.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
popupParent,
chartThemeOverrides,
rowData,
onGridReady,
onFirstDataRendered,
onChartCreated,
onChartRangeSelectionChanged,
onChartOptionsChanged,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
height: 300px;
flex: none;
}
.my-chart {
height: 400px;
flex: none;
}
Standalone Chart Events Copy Link
It is possible to subscribe to the AG Charts Events using the theme based configuration via the chartThemeOverrides grid option:
<ag-grid-vue
:chartThemeOverrides="chartThemeOverrides"
/* other grid options ... */>
</ag-grid-vue>
this.chartThemeOverrides = {
common: {
legend: {
listeners: {
legendItemClick: (e) => console.log('legendItemClick', e)
}
},
listeners: {
seriesNodeClick: (e) => console.log('seriesNodeClick', e)
}
}
;Note that the chartThemeOverrides grid option maps to AG Charts Theme Overrides.
The example below demonstrates Standalone Charts Events subscription:
- Click on the bars in the series and observe that the
seriesNodeClicklistener emits a console message. - Click on a legend item and observe that the
legendItemClicklistener emits a console message.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./style.css";
import { AgChartLegendClickEvent, AgNodeClickEvent } from "ag-charts-community";
import { AgChartsEnterpriseModule } from "ag-charts-enterprise";
import {
AgChartThemeOverrides,
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
FirstDataRenderedEvent,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
IntegratedChartsModule,
RowGroupingModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
IntegratedChartsModule.with(AgChartsEnterpriseModule),
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div class="wrapper">
<ag-grid-vue
style="width: 100%; height: 100%;"
class="my-grid"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:cellSelection="true"
:popupParent="popupParent"
:enableCharts="true"
:chartThemeOverrides="chartThemeOverrides"
:rowData="rowData"
@first-data-rendered="onFirstDataRendered"></ag-grid-vue>
<div id="myChart" class="my-chart"></div>
</div>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "Month", chartDataType: "category", width: 150 },
{ field: "Sunshine (hours)", chartDataType: "series" },
{ field: "Rainfall (mm)", chartDataType: "series" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
});
const popupParent = ref<HTMLElement | null>(document.body);
const chartThemeOverrides = ref<AgChartThemeOverrides>({
common: {
legend: {
listeners: {
legendItemClick: (e: AgChartLegendClickEvent) =>
console.log("legendItemClick", e),
},
},
listeners: {
seriesNodeClick: (e: AgNodeClickEvent<any, any>) =>
console.log("seriesNodeClick", e),
},
},
});
const rowData = ref<any[]>(null);
function onFirstDataRendered(params: FirstDataRenderedEvent) {
params.api.createRangeChart({
chartContainer: document.querySelector("#myChart") as HTMLElement,
cellRange: { columns: ["Month", "Sunshine (hours)", "Rainfall (mm)"] },
chartType: "groupedColumn",
});
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => {
rowData.value = data;
};
fetch("https://www.ag-grid.com/example-assets/weather-se-england.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
popupParent,
chartThemeOverrides,
rowData,
onGridReady,
onFirstDataRendered,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
height: 300px;
flex: none;
}
.my-chart {
height: 400px;
flex: none;
}